### Type parameters

- #### TRequest: Request

- #### TOptions: CoreOptions

- #### TUriUrlOptions

### Hierarchy

- RequestAPI<TRequest, TOptions, TUriUrlOptions>
  - DefaultUriUrlRequestApi

### Callable

- __call(callback?: RequestCallback): TRequest
- __call(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- __call(uri: string, callback?: RequestCallback): TRequest
- __call(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest

- - Defined in node_modules/@types/request/index.d.ts:80

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- - Defined in node_modules/@types/request/index.d.ts:33

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- - Defined in node_modules/@types/request/index.d.ts:35

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- - Defined in node_modules/@types/request/index.d.ts:36

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

## Index

### Properties

- debug

### Methods

- cookie
- defaults
- del
- delete
- forever
- get
- head
- initParams
- jar
- patch
- post
- put

## Properties

### debug

debug: boolean

Inherited from RequestAPI.debug

- Defined in node_modules/@types/request/index.d.ts:74

## Methods

### cookie

- cookie(str: string): Cookie | undefined

- Inherited from RequestAPI.cookie

  - Defined in node_modules/@types/request/index.d.ts:72

  #### Parameters

  - ##### str: string

  #### Returns Cookie | undefined

### defaults

- defaults(options: TOptions): DefaultUriUrlRequestApi<TRequest, TOptions, OptionalUriUrl>

- Overrides RequestAPI.defaults

  - Defined in node_modules/@types/request/index.d.ts:80

  #### Parameters

  - ##### options: TOptions

  #### Returns DefaultUriUrlRequestApi<TRequest, TOptions, OptionalUriUrl>

### del

- del(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- del(uri: string, callback?: RequestCallback): TRequest
- del(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest
- del(callback?: RequestCallback): TRequest

- Overrides RequestAPI.del

  - Defined in node_modules/@types/request/index.d.ts:108

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.del

  - Defined in node_modules/@types/request/index.d.ts:109

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.del

  - Defined in node_modules/@types/request/index.d.ts:110

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.del

  - Defined in node_modules/@types/request/index.d.ts:111

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

### delete

- delete(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- delete(uri: string, callback?: RequestCallback): TRequest
- delete(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest
- delete(callback?: RequestCallback): TRequest

- Overrides RequestAPI.delete

  - Defined in node_modules/@types/request/index.d.ts:113

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.delete

  - Defined in node_modules/@types/request/index.d.ts:114

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.delete

  - Defined in node_modules/@types/request/index.d.ts:115

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.delete

  - Defined in node_modules/@types/request/index.d.ts:116

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

### forever

- forever(agentOptions: any, optionsArg: any): TRequest

- Inherited from RequestAPI.forever

  - Defined in node_modules/@types/request/index.d.ts:70

  #### Parameters

  - ##### agentOptions: any

  - ##### optionsArg: any

  #### Returns TRequest

### get

- get(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- get(uri: string, callback?: RequestCallback): TRequest
- get(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest
- get(callback?: RequestCallback): TRequest

- Overrides RequestAPI.get

  - Defined in node_modules/@types/request/index.d.ts:83

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.get

  - Defined in node_modules/@types/request/index.d.ts:84

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.get

  - Defined in node_modules/@types/request/index.d.ts:85

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.get

  - Defined in node_modules/@types/request/index.d.ts:86

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

### head

- head(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- head(uri: string, callback?: RequestCallback): TRequest
- head(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest
- head(callback?: RequestCallback): TRequest

- Overrides RequestAPI.head

  - Defined in node_modules/@types/request/index.d.ts:98

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.head

  - Defined in node_modules/@types/request/index.d.ts:99

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.head

  - Defined in node_modules/@types/request/index.d.ts:100

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.head

  - Defined in node_modules/@types/request/index.d.ts:101

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

### initParams

- initParams(uri: string, options?: TOptions, callback?: RequestCallback): RequiredUriUrl & TOptions
- initParams(uriOrOpts: string | RequiredUriUrl & TOptions, callback?: RequestCallback): RequiredUriUrl & TOptions

- Inherited from RequestAPI.initParams

  - Defined in node_modules/@types/request/index.d.ts:67

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns RequiredUriUrl & TOptions

- Inherited from RequestAPI.initParams

  - Defined in node_modules/@types/request/index.d.ts:68

  #### Parameters

  - ##### uriOrOpts: string | RequiredUriUrl & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns RequiredUriUrl & TOptions

### jar

- jar(store?: any): CookieJar

- Inherited from RequestAPI.jar

  - Defined in node_modules/@types/request/index.d.ts:71

  #### Parameters

  - ##### Optional store: any

  #### Returns CookieJar

### patch

- patch(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- patch(uri: string, callback?: RequestCallback): TRequest
- patch(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest
- patch(callback?: RequestCallback): TRequest

- Overrides RequestAPI.patch

  - Defined in node_modules/@types/request/index.d.ts:103

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.patch

  - Defined in node_modules/@types/request/index.d.ts:104

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.patch

  - Defined in node_modules/@types/request/index.d.ts:105

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.patch

  - Defined in node_modules/@types/request/index.d.ts:106

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

### post

- post(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- post(uri: string, callback?: RequestCallback): TRequest
- post(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest
- post(callback?: RequestCallback): TRequest

- Overrides RequestAPI.post

  - Defined in node_modules/@types/request/index.d.ts:88

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.post

  - Defined in node_modules/@types/request/index.d.ts:89

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.post

  - Defined in node_modules/@types/request/index.d.ts:90

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.post

  - Defined in node_modules/@types/request/index.d.ts:91

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

### put

- put(uri: string, options?: TOptions, callback?: RequestCallback): TRequest
- put(uri: string, callback?: RequestCallback): TRequest
- put(options: TUriUrlOptions & TOptions, callback?: RequestCallback): TRequest
- put(callback?: RequestCallback): TRequest

- Overrides RequestAPI.put

  - Defined in node_modules/@types/request/index.d.ts:93

  #### Parameters

  - ##### uri: string

  - ##### Optional options: TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.put

  - Defined in node_modules/@types/request/index.d.ts:94

  #### Parameters

  - ##### uri: string

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.put

  - Defined in node_modules/@types/request/index.d.ts:95

  #### Parameters

  - ##### options: TUriUrlOptions & TOptions

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

- Overrides RequestAPI.put

  - Defined in node_modules/@types/request/index.d.ts:96

  #### Parameters

  - ##### Optional callback: RequestCallback

  #### Returns TRequest

Generated using TypeDoc